org.apache.lucene.index

## Class SegmentReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.AtomicReader
    - - org.apache.lucene.index.SegmentReader

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public final class SegmentReader
      extends AtomicReader

  IndexReader implementation over a single segment.

  Instances pointing to the same segment (but with different deletes, etc) may share the same core data.

  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `SegmentReader.CoreClosedListener` Called when the shared core for this SegmentReader is closed.

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.ReaderClosedListener`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SegmentReader(SegmentInfoPerCommit si, int termInfosIndexDivisor, IOContext context)` Constructs a new SegmentReader with a new core.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCoreClosedListener(SegmentReader.CoreClosedListener listener)` Expert: adds a CoreClosedListener to this reader's shared core
    `Directory` | `directory()` Returns the directory this index resides in.
    `protected void` | `doClose()` Implements close.
    `void` | `document(int docID, StoredFieldVisitor visitor)` Expert: visits the fields of a stored document, for custom processing/loading of each field.
    `Fields` | `fields()` Returns `Fields` for this reader.
    `BinaryDocValues` | `getBinaryDocValues(String field)` Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field.
    `Object` | `getCombinedCoreAndDeletesKey()` Expert: Returns a key for this IndexReader that also includes deletions, so FieldCache/CachingWrapperFilter can find it again.
    `Object` | `getCoreCacheKey()` Expert: Returns a key for this IndexReader, so FieldCache/CachingWrapperFilter can find it again.
    `FieldInfos` | `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
    `StoredFieldsReader` | `getFieldsReader()` Expert: retrieve thread-private `StoredFieldsReader`
    `Bits` | `getLiveDocs()` Returns the `Bits` representing live (not deleted) docs.
    `NumericDocValues` | `getNormValues(String field)` Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
    `NumericDocValues` | `getNumericDocValues(String field)` Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field.
    `String` | `getSegmentName()` Return the name of the segment this reader is reading.
    `SortedDocValues` | `getSortedDocValues(String field)` Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
    `SortedSetDocValues` | `getSortedSetDocValues(String field)` Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
    `int` | `getTermInfosIndexDivisor()` Returns term infos index divisor originally passed to `SegmentReader(SegmentInfoPerCommit, int, IOContext)`.
    `Fields` | `getTermVectors(int docID)` Retrieve term vectors for this document, or null if term vectors were not indexed.
    `TermVectorsReader` | `getTermVectorsReader()` Expert: retrieve thread-private `TermVectorsReader`
    `boolean` | `hasDeletions()` Returns true if any documents have been deleted
    `int` | `maxDoc()` Returns one greater than the largest possible document number.
    `int` | `numDocs()` Returns the number of documents in this index.
    `void` | `removeCoreClosedListener(SegmentReader.CoreClosedListener listener)` Expert: removes a CoreClosedListener from this reader's shared core
    `String` | `toString()`

    - ### Methods inherited from class org.apache.lucene.index.AtomicReader

      `docFreq, getContext, hasNorms, termDocsEnum, termPositionsEnum, terms, totalTermFreq`

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `addReaderClosedListener, close, decRef, document, document, ensureOpen, equals, getRefCount, getTermVector, hashCode, incRef, leaves, numDeletedDocs, open, open, open, open, open, registerParentReader, removeReaderClosedListener, tryIncRef`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SegmentReader

          public SegmentReader(SegmentInfoPerCommit si,
                       int termInfosIndexDivisor,
                       IOContext context)
                        throws IOException

      Constructs a new SegmentReader with a new core.
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `IOException` - if there is a low-level IO error

  - ### Method Detail

    - #### getLiveDocs

          public Bits getLiveDocs()

      Description copied from class: `AtomicReader`
      Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live). The returned instance has been safely published for use by multiple threads without additional synchronization.
      Specified by:
        `getLiveDocs` in class `AtomicReader`

    - #### doClose

          protected void doClose()
                          throws IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `IOException`

    - #### hasDeletions

          public boolean hasDeletions()

      Description copied from class: `IndexReader`
      Returns true if any documents have been deleted
      Specified by:
        `hasDeletions` in class `IndexReader`

    - #### getFieldInfos

          public FieldInfos getFieldInfos()

      Description copied from class: `AtomicReader`
      Get the `FieldInfos` describing all fields in this reader.
      Specified by:
        `getFieldInfos` in class `AtomicReader`

    - #### getFieldsReader

          public StoredFieldsReader getFieldsReader()

      Expert: retrieve thread-private `StoredFieldsReader`
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### document

          public void document(int docID,
                      StoredFieldVisitor visitor)
                        throws IOException

      Description copied from class: `IndexReader`
      Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.
      Specified by:
        `document` in class `IndexReader`
      Throws:
        `IOException`

    - #### fields

          public Fields fields()

      Description copied from class: `AtomicReader`
      Returns `Fields` for this reader. This method may return null if the reader has no postings.
      Specified by:
        `fields` in class `AtomicReader`

    - #### numDocs

          public int numDocs()

      Description copied from class: `IndexReader`
      Returns the number of documents in this index.
      Specified by:
        `numDocs` in class `IndexReader`

    - #### maxDoc

          public int maxDoc()

      Description copied from class: `IndexReader`
      Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
      Specified by:
        `maxDoc` in class `IndexReader`

    - #### getTermVectorsReader

          public TermVectorsReader getTermVectorsReader()

      Expert: retrieve thread-private `TermVectorsReader`
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getTermVectors

          public Fields getTermVectors(int docID)
                                throws IOException

      Description copied from class: `IndexReader`
      Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).
      Specified by:
        `getTermVectors` in class `IndexReader`
      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getSegmentName

          public String getSegmentName()

      Return the name of the segment this reader is reading.

    - #### directory

          public Directory directory()

      Returns the directory this index resides in.

    - #### getCoreCacheKey

          public Object getCoreCacheKey()

      Description copied from class: `IndexReader`
      Expert: Returns a key for this IndexReader, so FieldCache/CachingWrapperFilter can find it again. This key must not have equals()/hashCode() methods, so "equals" means "identical".
      Overrides:
        `getCoreCacheKey` in class `IndexReader`

    - #### getCombinedCoreAndDeletesKey

          public Object getCombinedCoreAndDeletesKey()

      Description copied from class: `IndexReader`
      Expert: Returns a key for this IndexReader that also includes deletions, so FieldCache/CachingWrapperFilter can find it again. This key must not have equals()/hashCode() methods, so "equals" means "identical".
      Overrides:
        `getCombinedCoreAndDeletesKey` in class `IndexReader`

    - #### getTermInfosIndexDivisor

          public int getTermInfosIndexDivisor()

      Returns term infos index divisor originally passed to `SegmentReader(SegmentInfoPerCommit, int, IOContext)`.

    - #### getNumericDocValues

          public NumericDocValues getNumericDocValues(String field)
                                               throws IOException

      Description copied from class: `AtomicReader`
      Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getNumericDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getBinaryDocValues

          public BinaryDocValues getBinaryDocValues(String field)
                                             throws IOException

      Description copied from class: `AtomicReader`
      Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getBinaryDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getSortedDocValues

          public SortedDocValues getSortedDocValues(String field)
                                             throws IOException

      Description copied from class: `AtomicReader`
      Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getSortedSetDocValues

          public SortedSetDocValues getSortedSetDocValues(String field)
                                                   throws IOException

      Description copied from class: `AtomicReader`
      Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedSetDocValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### getNormValues

          public NumericDocValues getNormValues(String field)
                                         throws IOException

      Description copied from class: `AtomicReader`
      Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getNormValues` in class `AtomicReader`
      Throws:
        `IOException`

    - #### addCoreClosedListener

          public void addCoreClosedListener(SegmentReader.CoreClosedListener listener)

      Expert: adds a CoreClosedListener to this reader's shared core

    - #### removeCoreClosedListener

          public void removeCoreClosedListener(SegmentReader.CoreClosedListener listener)

      Expert: removes a CoreClosedListener from this reader's shared core

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.